diff --git a/target/linux/sunxi/patches-3.18/301-add-bananapro.diff b/target/linux/sunxi/patches-3.18/301-add-bananapro.diff
index 2634240..a5d7154 100644
--- a/target/linux/sunxi/patches-3.18/301-add-bananapro.diff
+++ b/target/linux/sunxi/patches-3.18/301-add-bananapro.diff
@@ -12,27 +12,28 @@ diff -ruN old/arch/arm/boot/dts/Makefile new/arch/arm/boot/dts/Makefile
 diff -ruN old/arch/arm/boot/dts/sun7i-a20-bananapro.dts new/arch/arm/boot/dts/sun7i-a20-bananapro.dts
 --- old/arch/arm/boot/dts/sun7i-a20-bananapro.dts	1970-01-01 01:00:00.000000000 +0100
 +++ new/arch/arm/boot/dts/sun7i-a20-bananapro.dts	2015-01-06 09:31:18.290582574 +0100
-@@ -0,0 +1,232 @@
+@@ -0,0 +1,273 @@
 +/*
 + * Copyright 2014 Zoltan HERPAI <wigyori@uid0.hu>
++ * Copyright 2015 Hans de Goede <hdegoede@xxxxxxxxxx>
 + *
 + * This file is dual-licensed: you can use it either under the terms
 + * of the GPL or the X11 license, at your option. Note that this dual
 + * licensing only applies to this file, and not this project as a
 + * whole.
 + *
-+ *  a) This library is free software; you can redistribute it and/or
++ *  a) This file is free software; you can redistribute it and/or
 + *     modify it under the terms of the GNU General Public License as
 + *     published by the Free Software Foundation; either version 2 of the
 + *     License, or (at your option) any later version.
 + *
-+ *     This library is distributed in the hope that it will be useful,
++ *     This file is distributed in the hope that it will be useful,
 + *     but WITHOUT ANY WARRANTY; without even the implied warranty of
 + *     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 + *     GNU General Public License for more details.
 + *
 + *     You should have received a copy of the GNU General Public
-+ *     License along with this library; if not, write to the Free
++ *     License along with this file; if not, write to the Free
 + *     Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,
 + *     MA 02110-1301 USA
 + *
@@ -132,6 +133,20 @@ diff -ruN old/arch/arm/boot/dts/sun7i-a20-bananapro.dts new/arch/arm/boot/dts/su
 +		};
 +
 +		pinctrl@01c20800 {
++			usb1_vbus_pin_bananapro: usb1_vbus_pin@0 {
++				allwinner,pins = "PH0";
++				allwinner,function = "gpio_out";
++				allwinner,drive = <0>;
++				allwinner,pull = <0>;
++			};
++
++			usb2_vbus_pin_bananapro: usb2_vbus_pin@0 {
++				allwinner,pins = "PH1";
++				allwinner,function = "gpio_out";
++				allwinner,drive = <0>;
++				allwinner,pull = <0>;
++			};
++
 +			mmc0_cd_pin_bananapro: mmc0_cd_pin@0 {
 +				allwinner,pins = "PH10";
 +				allwinner,function = "gpio_in";
@@ -139,6 +154,13 @@ diff -ruN old/arch/arm/boot/dts/sun7i-a20-bananapro.dts new/arch/arm/boot/dts/su
 +				allwinner,pull = <1>;
 +			};
 +
++			vmmc3_pin_bananapro: vmmc3_pin@0 {
++				allwinner,pins = "PH22";
++				allwinner,function = "gpio_out";
++				allwinner,drive = <0>;
++				allwinner,pull = <0>;
++			};
++
 +			gmac_power_pin_bananapro: gmac_power_pin@0 {
 +				allwinner,pins = "PH23";
 +				allwinner,function = "gpio_out";
@@ -147,7 +169,7 @@ diff -ruN old/arch/arm/boot/dts/sun7i-a20-bananapro.dts new/arch/arm/boot/dts/su
 +			};
 +
 +			led_pins_bananapro: led_pins@0 {
-+				allwinner,pins = "PH24";
++				allwinner,pins = "PH24", "PG2";
 +				allwinner,function = "gpio_out";
 +				allwinner,drive = <0>;
 +				allwinner,pull = <0>;
@@ -166,9 +188,9 @@ diff -ruN old/arch/arm/boot/dts/sun7i-a20-bananapro.dts new/arch/arm/boot/dts/su
 +			status = "okay";
 +		};
 +
-+		uart3: serial@01c28c00 {
++		uart2: serial@01c28800 {
 +			pinctrl-names = "default";
-+			pinctrl-0 = <&uart3_pins_b>;
++			pinctrl-0 = <&uart2_pins_a>;
 +			status = "okay";
 +		};
 +
@@ -223,13 +245,21 @@ diff -ruN old/arch/arm/boot/dts/sun7i-a20-bananapro.dts new/arch/arm/boot/dts/su
 +			label = "bananapro:green:usr";
 +			gpios = <&pio 7 24 0>;
 +		};
++		blue {
++			label = "bananapro:blue:usr";
++			gpios = <&pio 6 2 0>;
++		};
 +	};
 +
 +	reg_usb1_vbus: usb1-vbus {
++		pinctrl-0 = <&usb1_vbus_pin_bananapro>;
++		gpio = <&pio 7 0 0>; /* PH0 */
 +		status = "okay";
 +	};
 +
 +	reg_usb2_vbus: usb2-vbus {
++		pinctrl-0 = <&usb2_vbus_pin_bananapro>;
++		gpio = <&pio 7 1 0>; /* PH1 */
 +		status = "okay";
 +	};
 +
@@ -240,8 +270,19 @@ diff -ruN old/arch/arm/boot/dts/sun7i-a20-bananapro.dts new/arch/arm/boot/dts/su
 +		regulator-name = "gmac-3v3";
 +		regulator-min-microvolt = <3300000>;
 +		regulator-max-microvolt = <3300000>;
-+		startup-delay-us = <50000>;
++		startup-delay-us = <100000>;
 +		enable-active-high;
 +		gpio = <&pio 7 23 0>;
 +	};
++
++	reg_vmmc3: vmmc3 {
++		compatible = "regulator-fixed";
++		pinctrl-names = "default";
++		pinctrl-0 = <&vmmc3_pin_bananapro>;
++		regulator-name = "vmmc3";
++		regulator-min-microvolt = <3300000>;
++		regulator-max-microvolt = <3300000>;
++		enable-active-high;
++		gpio = <&pio 7 22 0>;
++	};
 +};