diff --git a/target/linux/generic/config-3.10 b/target/linux/generic/config-3.10
index 4299c57..4fa2363 100644
--- a/target/linux/generic/config-3.10
+++ b/target/linux/generic/config-3.10
@@ -829,7 +829,7 @@ CONFIG_EVENTFD=y
 # CONFIG_EWRK3 is not set
 CONFIG_EXPERIMENTAL=y
 CONFIG_EXPERT=y
-# CONFIG_EXPORTFS is not set
+CONFIG_EXPORTFS=y
 # CONFIG_EXT2_FS is not set
 # CONFIG_EXT2_FS_XATTR is not set
 # CONFIG_EXT2_FS_XIP is not set
@@ -927,7 +927,7 @@ CONFIG_FAT_DEFAULT_IOCHARSET="iso8859-1"
 # CONFIG_FCOE_FNIC is not set
 # CONFIG_FDDI is not set
 # CONFIG_FEALNX is not set
-# CONFIG_FHANDLE is not set
+CONFIG_FHANDLE=y
 CONFIG_FIB_RULES=y
 CONFIG_FILE_LOCKING=y
 # CONFIG_FIREWIRE is not set
diff --git a/target/linux/generic/config-3.13 b/target/linux/generic/config-3.13
index 8dff7e1..6e88c72 100644
--- a/target/linux/generic/config-3.13
+++ b/target/linux/generic/config-3.13
@@ -896,7 +896,7 @@ CONFIG_EVENTFD=y
 # CONFIG_EWRK3 is not set
 CONFIG_EXPERIMENTAL=y
 CONFIG_EXPERT=y
-# CONFIG_EXPORTFS is not set
+CONFIG_EXPORTFS=y
 # CONFIG_EXT2_FS is not set
 # CONFIG_EXT2_FS_XATTR is not set
 # CONFIG_EXT2_FS_XIP is not set
@@ -996,7 +996,7 @@ CONFIG_FAT_DEFAULT_IOCHARSET="iso8859-1"
 # CONFIG_FCOE_FNIC is not set
 # CONFIG_FDDI is not set
 # CONFIG_FEALNX is not set
-# CONFIG_FHANDLE is not set
+CONFIG_FHANDLE=y
 CONFIG_FIB_RULES=y
 CONFIG_FILE_LOCKING=y
 # CONFIG_FIREWIRE is not set
diff --git a/target/linux/generic/config-3.14 b/target/linux/generic/config-3.14
index 6e70ba7..a51b347 100644
--- a/target/linux/generic/config-3.14
+++ b/target/linux/generic/config-3.14
@@ -920,7 +920,7 @@ CONFIG_EVENTFD=y
 # CONFIG_EWRK3 is not set
 CONFIG_EXPERIMENTAL=y
 CONFIG_EXPERT=y
-# CONFIG_EXPORTFS is not set
+CONFIG_EXPORTFS=y
 # CONFIG_EXT2_FS is not set
 # CONFIG_EXT2_FS_XATTR is not set
 # CONFIG_EXT2_FS_XIP is not set
@@ -1021,7 +1021,7 @@ CONFIG_FAT_DEFAULT_IOCHARSET="iso8859-1"
 # CONFIG_FCOE_FNIC is not set
 # CONFIG_FDDI is not set
 # CONFIG_FEALNX is not set
-# CONFIG_FHANDLE is not set
+CONFIG_FHANDLE=y
 CONFIG_FIB_RULES=y
 CONFIG_FILE_LOCKING=y
 # CONFIG_FIREWIRE is not set
diff --git a/target/linux/generic/config-3.18 b/target/linux/generic/config-3.18
index 5487bdd..a7d8155 100644
--- a/target/linux/generic/config-3.18
+++ b/target/linux/generic/config-3.18
@@ -968,7 +968,7 @@ CONFIG_EVENTFD=y
 # CONFIG_EWRK3 is not set
 CONFIG_EXPERIMENTAL=y
 CONFIG_EXPERT=y
-# CONFIG_EXPORTFS is not set
+CONFIG_EXPORTFS=y
 # CONFIG_EXT2_FS is not set
 # CONFIG_EXT2_FS_XATTR is not set
 # CONFIG_EXT2_FS_XIP is not set
@@ -1070,7 +1070,7 @@ CONFIG_FAT_DEFAULT_IOCHARSET="iso8859-1"
 # CONFIG_FDDI is not set
 # CONFIG_FEALNX is not set
 # CONFIG_FENCE_TRACE is not set
-# CONFIG_FHANDLE is not set
+CONFIG_FHANDLE=y
 CONFIG_FIB_RULES=y
 CONFIG_FILE_LOCKING=y
 # CONFIG_FIREWIRE is not set
diff --git a/target/linux/generic/config-3.19 b/target/linux/generic/config-3.19
index a5405f4..001e4ca 100644
--- a/target/linux/generic/config-3.19
+++ b/target/linux/generic/config-3.19
@@ -974,7 +974,7 @@ CONFIG_EVENTFD=y
 # CONFIG_EWRK3 is not set
 CONFIG_EXPERIMENTAL=y
 CONFIG_EXPERT=y
-# CONFIG_EXPORTFS is not set
+CONFIG_EXPORTFS=y
 # CONFIG_EXT2_FS is not set
 # CONFIG_EXT2_FS_XATTR is not set
 # CONFIG_EXT2_FS_XIP is not set
@@ -1076,7 +1076,7 @@ CONFIG_FAT_DEFAULT_IOCHARSET="iso8859-1"
 # CONFIG_FDDI is not set
 # CONFIG_FEALNX is not set
 # CONFIG_FENCE_TRACE is not set
-# CONFIG_FHANDLE is not set
+CONFIG_FHANDLE=y
 CONFIG_FIB_RULES=y
 CONFIG_FILE_LOCKING=y
 # CONFIG_FIREWIRE is not set
diff --git a/target/linux/generic/config-3.8 b/target/linux/generic/config-3.8
index 343c0dd..b962315 100644
--- a/target/linux/generic/config-3.8
+++ b/target/linux/generic/config-3.8
@@ -802,7 +802,7 @@ CONFIG_EVENTFD=y
 # CONFIG_EWRK3 is not set
 CONFIG_EXPERIMENTAL=y
 CONFIG_EXPERT=y
-# CONFIG_EXPORTFS is not set
+CONFIG_EXPORTFS=y
 # CONFIG_EXT2_FS is not set
 # CONFIG_EXT2_FS_XATTR is not set
 # CONFIG_EXT2_FS_XIP is not set
@@ -897,7 +897,7 @@ CONFIG_FAT_DEFAULT_IOCHARSET="iso8859-1"
 # CONFIG_FCOE_FNIC is not set
 # CONFIG_FDDI is not set
 # CONFIG_FEALNX is not set
-# CONFIG_FHANDLE is not set
+CONFIG_FHANDLE=y
 CONFIG_FIB_RULES=y
 CONFIG_FILE_LOCKING=y
 # CONFIG_FIREWIRE is not set