diff --git a/target/linux/bcm53xx/config-3.14 b/target/linux/bcm53xx/config-3.14
index d058320..9f27c04 100644
--- a/target/linux/bcm53xx/config-3.14
+++ b/target/linux/bcm53xx/config-3.14
@@ -193,7 +193,6 @@ CONFIG_MTD_NAND_ECC=y
 CONFIG_MTD_SPI_BCM53XXSPIFLASH=y
 CONFIG_MTD_SPI_NOR=y
 # CONFIG_MTD_SPI_NOR_USE_4K_SECTORS is not set
-CONFIG_MTD_SPLIT_SUPPORT=y
 CONFIG_MTD_UBI=y
 CONFIG_MTD_UBI_BEB_LIMIT=20
 CONFIG_MTD_UBI_BLOCK=y
diff --git a/target/linux/bcm53xx/config-3.18 b/target/linux/bcm53xx/config-3.18
index e55d898..8f0b286 100644
--- a/target/linux/bcm53xx/config-3.18
+++ b/target/linux/bcm53xx/config-3.18
@@ -198,7 +198,6 @@ CONFIG_MTD_NAND_ECC=y
 # CONFIG_MTD_PHYSMAP_OF is not set
 CONFIG_MTD_SPI_BCM53XXSPIFLASH=y
 CONFIG_MTD_SPI_NOR=y
-CONFIG_MTD_SPLIT_SUPPORT=y
 CONFIG_MTD_UBI=y
 CONFIG_MTD_UBI_BEB_LIMIT=20
 CONFIG_MTD_UBI_BLOCK=y
diff --git a/target/linux/brcm63xx/config-3.14 b/target/linux/brcm63xx/config-3.14
index 05c7de2..cb15b78 100644
--- a/target/linux/brcm63xx/config-3.14
+++ b/target/linux/brcm63xx/config-3.14
@@ -154,7 +154,6 @@ CONFIG_MTD_M25P80=y
 CONFIG_MTD_PHYSMAP=y
 CONFIG_MTD_REDBOOT_PARTS=y
 CONFIG_MTD_REDBOOT_PARTS_UNALLOCATED=y
-CONFIG_MTD_SPLIT_SUPPORT=y
 CONFIG_NEED_DMA_MAP_STATE=y
 CONFIG_NEED_PER_CPU_KM=y
 CONFIG_NO_GENERIC_PCI_IOPORT_MAP=y
diff --git a/target/linux/brcm63xx/config-3.18 b/target/linux/brcm63xx/config-3.18
index d6ad385..168964d 100644
--- a/target/linux/brcm63xx/config-3.18
+++ b/target/linux/brcm63xx/config-3.18
@@ -162,7 +162,6 @@ CONFIG_MTD_PHYSMAP=y
 CONFIG_MTD_REDBOOT_PARTS=y
 CONFIG_MTD_REDBOOT_PARTS_UNALLOCATED=y
 CONFIG_MTD_SPI_NOR=y
-CONFIG_MTD_SPLIT_SUPPORT=y
 CONFIG_NEED_DMA_MAP_STATE=y
 CONFIG_NEED_PER_CPU_KM=y
 CONFIG_NO_GENERIC_PCI_IOPORT_MAP=y
diff --git a/target/linux/generic/config-3.14 b/target/linux/generic/config-3.14
index 27a8dd3..2b8df1b 100644
--- a/target/linux/generic/config-3.14
+++ b/target/linux/generic/config-3.14
@@ -2135,6 +2135,7 @@ CONFIG_MTD_SPLIT_FIRMWARE_NAME="firmware"
 # CONFIG_MTD_SPLIT_LZMA_FW is not set
 # CONFIG_MTD_SPLIT_SEAMA_FW is not set
 CONFIG_MTD_SPLIT_SQUASHFS_ROOT=y
+CONFIG_MTD_SPLIT_SUPPORT=y
 # CONFIG_MTD_SPLIT_TRX_FW is not set
 # CONFIG_MTD_SPLIT_TPLINK_FW is not set
 # CONFIG_MTD_SPLIT_UIMAGE_FW is not set
diff --git a/target/linux/generic/config-3.18 b/target/linux/generic/config-3.18
index f50211d..d54cd5c 100644
--- a/target/linux/generic/config-3.18
+++ b/target/linux/generic/config-3.18
@@ -2242,6 +2242,7 @@ CONFIG_MTD_SPLIT_FIRMWARE_NAME="firmware"
 # CONFIG_MTD_SPLIT_LZMA_FW is not set
 # CONFIG_MTD_SPLIT_SEAMA_FW is not set
 CONFIG_MTD_SPLIT_SQUASHFS_ROOT=y
+CONFIG_MTD_SPLIT_SUPPORT=y
 # CONFIG_MTD_SPLIT_TRX_FW is not set
 # CONFIG_MTD_SPLIT_TPLINK_FW is not set
 # CONFIG_MTD_SPLIT_UIMAGE_FW is not set
diff --git a/target/linux/generic/config-3.19 b/target/linux/generic/config-3.19
index d33f147..d474c7c 100644
--- a/target/linux/generic/config-3.19
+++ b/target/linux/generic/config-3.19
@@ -2254,6 +2254,7 @@ CONFIG_MTD_SPLIT_FIRMWARE_NAME="firmware"
 # CONFIG_MTD_SPLIT_LZMA_FW is not set
 # CONFIG_MTD_SPLIT_SEAMA_FW is not set
 CONFIG_MTD_SPLIT_SQUASHFS_ROOT=y
+CONFIG_MTD_SPLIT_SUPPORT=y
 # CONFIG_MTD_SPLIT_TRX_FW is not set
 # CONFIG_MTD_SPLIT_TPLINK_FW is not set
 # CONFIG_MTD_SPLIT_UIMAGE_FW is not set
diff --git a/target/linux/generic/config-4.0 b/target/linux/generic/config-4.0
index 62219bb..5ac2b32 100644
--- a/target/linux/generic/config-4.0
+++ b/target/linux/generic/config-4.0
@@ -2262,6 +2262,7 @@ CONFIG_MTD_SPLIT_FIRMWARE_NAME="firmware"
 # CONFIG_MTD_SPLIT_LZMA_FW is not set
 # CONFIG_MTD_SPLIT_SEAMA_FW is not set
 CONFIG_MTD_SPLIT_SQUASHFS_ROOT=y
+CONFIG_MTD_SPLIT_SUPPORT=y
 # CONFIG_MTD_SPLIT_TRX_FW is not set
 # CONFIG_MTD_SPLIT_TPLINK_FW is not set
 # CONFIG_MTD_SPLIT_UIMAGE_FW is not set
diff --git a/target/linux/ipq806x/config-3.18 b/target/linux/ipq806x/config-3.18
index 51f2de7..ddefa3b 100644
--- a/target/linux/ipq806x/config-3.18
+++ b/target/linux/ipq806x/config-3.18
@@ -226,7 +226,6 @@ CONFIG_MSM_MMCC_8974=y
 CONFIG_MTD_CMDLINE_PARTS=y
 CONFIG_MTD_M25P80=y
 CONFIG_MTD_SPI_NOR=y
-CONFIG_MTD_SPLIT_SUPPORT=y
 CONFIG_MULTI_IRQ_HANDLER=y
 CONFIG_MUTEX_SPIN_ON_OWNER=y
 CONFIG_NEED_DMA_MAP_STATE=y
diff --git a/target/linux/kirkwood/config-3.18 b/target/linux/kirkwood/config-3.18
index faab4dc..1c8dc5b 100644
--- a/target/linux/kirkwood/config-3.18
+++ b/target/linux/kirkwood/config-3.18
@@ -206,7 +206,6 @@ CONFIG_MTD_CMDLINE_PARTS=y
 CONFIG_MTD_NAND=y
 CONFIG_MTD_NAND_ECC=y
 CONFIG_MTD_NAND_ORION=y
-CONFIG_MTD_SPLIT_SUPPORT=y
 CONFIG_MTD_UBI=y
 CONFIG_MTD_UBI_BEB_LIMIT=20
 # CONFIG_MTD_UBI_BLOCK is not set
diff --git a/target/linux/lantiq/xrx200/config-default b/target/linux/lantiq/xrx200/config-default
index 110be3d..9a34938 100644
--- a/target/linux/lantiq/xrx200/config-default
+++ b/target/linux/lantiq/xrx200/config-default
@@ -42,7 +42,6 @@ CONFIG_MTD_NAND_ECC=y
 CONFIG_MTD_NAND_PLATFORM=y
 CONFIG_MTD_NAND_XWAY=y
 # CONFIG_MTD_PHYSMAP_OF is not set
-CONFIG_MTD_SPLIT_SUPPORT=y
 CONFIG_MTD_UBI=y
 CONFIG_MTD_UBI_BEB_LIMIT=20
 CONFIG_MTD_UBI_BLOCK=y
diff --git a/target/linux/lantiq/xway/config-default b/target/linux/lantiq/xway/config-default
index eec9674..cf0c2b7 100644
--- a/target/linux/lantiq/xway/config-default
+++ b/target/linux/lantiq/xway/config-default
@@ -40,7 +40,6 @@ CONFIG_MTD_NAND_ECC=y
 CONFIG_MTD_NAND_PLATFORM=y
 CONFIG_MTD_NAND_XWAY=y
 # CONFIG_MTD_PHYSMAP_OF is not set
-CONFIG_MTD_SPLIT_SUPPORT=y
 CONFIG_MTD_SPLIT_UIMAGE_FW=y
 CONFIG_MTD_UBI=y
 CONFIG_MTD_UBI_BEB_LIMIT=20
diff --git a/target/linux/mpc83xx/config-3.18 b/target/linux/mpc83xx/config-3.18
index ed270f6..473efde 100644
--- a/target/linux/mpc83xx/config-3.18
+++ b/target/linux/mpc83xx/config-3.18
@@ -207,7 +207,6 @@ CONFIG_MTD_NAND_ECC=y
 CONFIG_MTD_NAND_FSL_ELBC=y
 CONFIG_MTD_NAND_FSL_UPM=y
 CONFIG_MTD_NAND_RB_PPC=y
-CONFIG_MTD_SPLIT_SUPPORT=y
 CONFIG_MTD_UBI=y
 CONFIG_MTD_UBI_BEB_LIMIT=20
 # CONFIG_MTD_UBI_BLOCK is not set
diff --git a/target/linux/mpc85xx/config-3.18 b/target/linux/mpc85xx/config-3.18
index 9535301..461ed7b 100644
--- a/target/linux/mpc85xx/config-3.18
+++ b/target/linux/mpc85xx/config-3.18
@@ -160,7 +160,6 @@ CONFIG_MPIC_TIMER=y
 # CONFIG_MTD_CFI is not set
 CONFIG_MTD_M25P80=y
 CONFIG_MTD_SPI_NOR=y
-CONFIG_MTD_SPLIT_SUPPORT=y
 # CONFIG_NEED_DMA_MAP_STATE is not set
 # CONFIG_NEED_PER_CPU_EMBED_FIRST_CHUNK is not set
 CONFIG_NEED_PER_CPU_KM=y
diff --git a/target/linux/mpc85xx/config-3.19 b/target/linux/mpc85xx/config-3.19
index 9535301..461ed7b 100644
--- a/target/linux/mpc85xx/config-3.19
+++ b/target/linux/mpc85xx/config-3.19
@@ -160,7 +160,6 @@ CONFIG_MPIC_TIMER=y
 # CONFIG_MTD_CFI is not set
 CONFIG_MTD_M25P80=y
 CONFIG_MTD_SPI_NOR=y
-CONFIG_MTD_SPLIT_SUPPORT=y
 # CONFIG_NEED_DMA_MAP_STATE is not set
 # CONFIG_NEED_PER_CPU_EMBED_FIRST_CHUNK is not set
 CONFIG_NEED_PER_CPU_KM=y
diff --git a/target/linux/mvebu/config-3.18 b/target/linux/mvebu/config-3.18
index b4a372d..de849d7 100644
--- a/target/linux/mvebu/config-3.18
+++ b/target/linux/mvebu/config-3.18
@@ -233,7 +233,6 @@ CONFIG_MTD_NAND_ECC=y
 CONFIG_MTD_NAND_PXA3xx=y
 CONFIG_MTD_SPI_NOR=y
 CONFIG_MTD_SPLIT_FIRMWARE=y
-CONFIG_MTD_SPLIT_SUPPORT=y
 CONFIG_MTD_UBI=y
 CONFIG_MTD_UBI_BEB_LIMIT=20
 CONFIG_MTD_UBI_BLOCK=y
diff --git a/target/linux/mvebu/config-3.19 b/target/linux/mvebu/config-3.19
index eb2f95b..63c8e8f 100644
--- a/target/linux/mvebu/config-3.19
+++ b/target/linux/mvebu/config-3.19
@@ -233,7 +233,6 @@ CONFIG_MTD_NAND_ECC=y
 CONFIG_MTD_NAND_PXA3xx=y
 CONFIG_MTD_SPI_NOR=y
 CONFIG_MTD_SPLIT_FIRMWARE=y
-CONFIG_MTD_SPLIT_SUPPORT=y
 CONFIG_MTD_UBI=y
 CONFIG_MTD_UBI_BEB_LIMIT=20
 CONFIG_MTD_UBI_BLOCK=y
diff --git a/target/linux/omap/config-3.18 b/target/linux/omap/config-3.18
index 453b3e2..39a8d30 100644
--- a/target/linux/omap/config-3.18
+++ b/target/linux/omap/config-3.18
@@ -358,7 +358,6 @@ CONFIG_MTD_NAND_OMAP_BCH=y
 CONFIG_MTD_NAND_OMAP_BCH_BUILD=y
 CONFIG_MTD_PHYSMAP=y
 # CONFIG_MTD_PHYSMAP_OF is not set
-CONFIG_MTD_SPLIT_SUPPORT=y
 CONFIG_MULTI_IRQ_HANDLER=y
 CONFIG_MUTEX_SPIN_ON_OWNER=y
 # CONFIG_MWIFIEX is not set
diff --git a/target/linux/ramips/mt7620/config-3.18 b/target/linux/ramips/mt7620/config-3.18
index 14d38a6..b5b2498 100644
--- a/target/linux/ramips/mt7620/config-3.18
+++ b/target/linux/ramips/mt7620/config-3.18
@@ -120,7 +120,6 @@ CONFIG_MTD_NAND_MT7620=y
 CONFIG_MTD_PHYSMAP=y
 CONFIG_MTD_SPI_NOR=y
 CONFIG_MTD_SPLIT_FIRMWARE=y
-CONFIG_MTD_SPLIT_SUPPORT=y
 CONFIG_MTD_SPLIT_TPLINK_FW=y
 CONFIG_MTD_SPLIT_UIMAGE_FW=y
 CONFIG_NEED_DMA_MAP_STATE=y
diff --git a/target/linux/ramips/mt7621/config-3.18 b/target/linux/ramips/mt7621/config-3.18
index 29c97f4..a8f7515 100644
--- a/target/linux/ramips/mt7621/config-3.18
+++ b/target/linux/ramips/mt7621/config-3.18
@@ -126,7 +126,6 @@ CONFIG_MTD_PHYSMAP=y
 CONFIG_MTD_SPI_NOR=y
 CONFIG_MTD_SPLIT_FIRMWARE=y
 CONFIG_MTD_SPLIT_SEAMA_FW=y
-CONFIG_MTD_SPLIT_SUPPORT=y
 CONFIG_MTD_SPLIT_TRX_FW=y
 CONFIG_MTD_SPLIT_UIMAGE_FW=y
 CONFIG_NEED_DMA_MAP_STATE=y
diff --git a/target/linux/ramips/mt7628/config-3.18 b/target/linux/ramips/mt7628/config-3.18
index b3dc853..b52a773 100644
--- a/target/linux/ramips/mt7628/config-3.18
+++ b/target/linux/ramips/mt7628/config-3.18
@@ -120,7 +120,6 @@ CONFIG_MTD_NAND_MT7620=y
 CONFIG_MTD_PHYSMAP=y
 CONFIG_MTD_SPI_NOR=y
 CONFIG_MTD_SPLIT_FIRMWARE=y
-CONFIG_MTD_SPLIT_SUPPORT=y
 CONFIG_MTD_SPLIT_UIMAGE_FW=y
 CONFIG_NEED_DMA_MAP_STATE=y
 CONFIG_NEED_PER_CPU_KM=y
diff --git a/target/linux/ramips/rt305x/config-3.18 b/target/linux/ramips/rt305x/config-3.18
index 593ce72..b246298 100644
--- a/target/linux/ramips/rt305x/config-3.18
+++ b/target/linux/ramips/rt305x/config-3.18
@@ -112,7 +112,6 @@ CONFIG_MTD_M25P80=y
 CONFIG_MTD_PHYSMAP=y
 CONFIG_MTD_SPLIT_FIRMWARE=y
 CONFIG_MTD_SPI_NOR=y
-CONFIG_MTD_SPLIT_SUPPORT=y
 CONFIG_MTD_SPLIT_UIMAGE_FW=y
 CONFIG_NEED_DMA_MAP_STATE=y
 CONFIG_NEED_PER_CPU_KM=y
diff --git a/target/linux/ramips/rt3883/config-3.18 b/target/linux/ramips/rt3883/config-3.18
index 483111a..33aef29 100644
--- a/target/linux/ramips/rt3883/config-3.18
+++ b/target/linux/ramips/rt3883/config-3.18
@@ -114,7 +114,6 @@ CONFIG_MTD_PHYSMAP=y
 CONFIG_MTD_SPLIT_FIRMWARE=y
 CONFIG_MTD_SPI_NOR=y
 CONFIG_MTD_SPLIT_SEAMA_FW=y
-CONFIG_MTD_SPLIT_SUPPORT=y
 CONFIG_MTD_SPLIT_UIMAGE_FW=y
 CONFIG_NEED_DMA_MAP_STATE=y
 CONFIG_NEED_PER_CPU_KM=y
diff --git a/target/linux/realview/config-3.18 b/target/linux/realview/config-3.18
index 50130cf..7af1470 100644
--- a/target/linux/realview/config-3.18
+++ b/target/linux/realview/config-3.18
@@ -188,7 +188,6 @@ CONFIG_MDIO_BOARDINFO=y
 CONFIG_MIGHT_HAVE_CACHE_L2X0=y
 CONFIG_MODULES_USE_ELF_REL=y
 CONFIG_MTD_CMDLINE_PARTS=y
-CONFIG_MTD_SPLIT_SUPPORT=y
 CONFIG_MULTI_IRQ_HANDLER=y
 CONFIG_MUTEX_SPIN_ON_OWNER=y
 CONFIG_NEED_DMA_MAP_STATE=y
diff --git a/target/linux/sunxi/config-3.18 b/target/linux/sunxi/config-3.18
index d96406e..6b5ca15 100644
--- a/target/linux/sunxi/config-3.18
+++ b/target/linux/sunxi/config-3.18
@@ -300,7 +300,6 @@ CONFIG_MMC_BLOCK=y
 # CONFIG_MMC_DEBUG is not set
 CONFIG_MMC_SUNXI=y
 CONFIG_MODULES_USE_ELF_REL=y
-CONFIG_MTD_SPLIT_SUPPORT=y
 CONFIG_MULTI_IRQ_HANDLER=y
 CONFIG_MUTEX_SPIN_ON_OWNER=y
 CONFIG_NAMESPACES=y
diff --git a/target/linux/x86/config-3.14 b/target/linux/x86/config-3.14
index 58bba53..8537d4d 100644
--- a/target/linux/x86/config-3.14
+++ b/target/linux/x86/config-3.14
@@ -262,7 +262,6 @@ CONFIG_MODULES_USE_ELF_REL=y
 CONFIG_MTD_BLOCK2MTD=y
 # CONFIG_MTD_CFI is not set
 # CONFIG_MTD_COMPLEX_MAPPINGS is not set
-CONFIG_MTD_SPLIT_SUPPORT=y
 # CONFIG_MTD_TS5500 is not set
 CONFIG_MTRR=y
 # CONFIG_MTRR_SANITIZER is not set